from sys import setrecursionlimit
import threading

setrecursionlimit(10 ** 9)
threading.stack_size(67108864)


def main():
    n, m, k = map(int, input().split())

    mat = [[0 for _ in range(n)] for _ in range(n)]

    for _ in range(m):
        i, j = map(int, input().split())
        i -= 1
        j -= 1
        mat[i][j], mat[j][i] = 1, 1

    def dff(p, h, v):
        v.add(p)
        if h == 0:
            return v
        nv = []
        for i in range(n):
            if i not in v and mat[p][i] == 1:
                nv.append(i)
        for w in nv:
            v = v | dff(w, h - 1, v)
        return v

    av = set()
    for i in range(k):
        p, h = map(int, input().split())
        p -= 1
        av = av | dff(p, h, av)
    print(len(av))
    av = list(av)
    for i in range(len(av)):
        if i != len(av) - 1:
            print(av[i] + 1, end=' ')
        else:
            print(av[i] + 1, end='')


thread = threading.Thread(target=main)
thread.start()
